import gtk
import gtk.glade
import subprocess
import os
import socket

import gettext
import locale


locale.textdomain("llxcfg-extnet-conf")
gettext.textdomain("llxcfg-extnet-conf")
_=gettext.gettext

class NetConfig:
	
	def __init__(self):

		if (os.path.exists("../rsrc/main.glade")):
			self.glade= gtk.glade.XML("../rsrc/main.glade")
		else:
			self.glade= gtk.glade.XML("/usr/share/llxcfg-extnet-conf/rsrc/main.glade")
			
		self.window=self.glade.get_widget("window1")
		self.window.set_title(_("External Interface configure"))
		self.window.set_icon(self.window.render_icon(gtk.STOCK_NETWORK,gtk.ICON_SIZE_MENU))
		self.interfaceCombobox = self.glade.get_widget("interfaceCombobox")
		self.dhcpRadiobutton = self.glade.get_widget("dhcpRadiobutton")
		self.manualRadiobutton = self.glade.get_widget("manualRadiobutton")
		self.manualoptionsTable = self.glade.get_widget("manualoptionsTable")
		self.ipEntry = self.glade.get_widget("ipEntry")
		self.netmaskEntry = self.glade.get_widget("netmaskEntry")
		self.gatewayEntry = self.glade.get_widget("gatewayEntry")
		self.extransEntry = self.glade.get_widget("extransEntry")
		self.ipLabel = self.glade.get_widget("ipLabel")
		self.netmaskLabel = self.glade.get_widget("netmaskLabel")
		self.gatewayLabel = self.glade.get_widget("gatewayLabel")
		self.extransLabel = self.glade.get_widget("extransLabel")
		self.applyButton = self.glade.get_widget("applyButton")
		self.cancelButton = self.glade.get_widget("cancelButton")

		self.window.connect("destroy",gtk.main_quit)
		self.applyButton.connect("clicked",self.applyButtonPress)
		self.cancelButton.connect("clicked",gtk.main_quit)
		self.dhcpRadiobutton.connect("clicked",self.dhcptoggled)
		self.manualRadiobutton.connect("clicked",self.manualtoggled)
		self.ipEntry.connect("focus-out-event",self.autogateway)
		self.ipEntry.connect("changed",self.ipcheckEntry)
		self.netmaskEntry.connect("changed",self.ipcheckEntry)
		self.gatewayEntry.connect("changed",self.ipcheckEntry)
		self.extransEntry.connect("changed",self.ipcheckEntry)
		self.manualoptionsTable.set_sensitive(False)
		self.replenish()		
		self.window.show_all()
		self.window.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		
		

		gtk.main()
		
	#def __init__
	
	def ipcheckEntry(self,component):
		component.modify_base(gtk.STATE_NORMAL,gtk.gdk.color_parse("#fff"))
		if not self.ipcheck(component.get_text()):
			component.modify_base(gtk.STATE_NORMAL,gtk.gdk.color_parse("#f00"))
	#def ipcheckEntry
	
	def ipcheck(self,ip):
		try:
			socket.inet_aton(ip)
			aux = ip.split(".")
			if(len(aux) == 4):
				return True
			else:
				return False
		except socket.error:
			return False
	#def ipcheck

	def autogateway(self,ipEntry,aux):
		if self.gatewayEntry.get_text() == "" :
			gateway = ipEntry.get_text().split(".")
			self.gatewayEntry.set_text(".".join(gateway[:len(gateway)-1])+".1")

	def replenish(self):
		pprocess = subprocess.Popen(["lliurex-net", "get_network_cards"],stdout = subprocess.PIPE,stderr = subprocess.PIPE)
		p2 = subprocess.Popen(["llxcfg-showvars", "SRV_NIC"],stdout = subprocess.PIPE,stderr = subprocess.PIPE)
		out = pprocess.stdout.readline().split(" ")
		try:
			out2 = p2.stdout.readline().split('=')[1]
			out2 = out2[out2.find("'")+1:out2.rfind("'")]
		except:
			out2 = ""
		for item in out:
			item = item.strip('\n')
			if item != "" and item != out2 :
				self.interfaceCombobox.append_text(item)
		self.interfaceCombobox.set_active(0)
		self.netmaskEntry.set_text("255.255.255.0")
		self.extransEntry.set_text("194.179.1.100")
		
	#def replenish
	
	def dhcptoggled(self,togglebutton):
		if togglebutton.get_active() :
			self.manualoptionsTable.set_sensitive(False)
	#def dhcptoggled

	def manualtoggled(self,togglebutton):
		if togglebutton.get_active() :
			self.manualoptionsTable.set_sensitive(True)
	#def dhcptoggled

	def applyButtonPress(self, pressedbutton):
		command = ["lliurex-srv-netfix",self.interfaceCombobox.get_active_text(),"--external"]
		allok = True
		listfails = []
		if self.dhcpRadiobutton.get_active():
			command.append("dhcp")
		else:	
			newip = self.ipEntry.get_text()
			newnetmask = self.netmaskEntry.get_text()
			newgateway = self.gatewayEntry.get_text()
			newextrans = self.extransEntry.get_text()
			if self.ipcheck(newip):
				command.append("-ip")
				command.append(newip)
			else:
				self.ipEntry.modify_base(gtk.STATE_NORMAL,gtk.gdk.color_parse("#f00"))	
				allok = False
			if self.ipcheck(newnetmask):
				command.append("-netmask")
				command.append(newnetmask)
			else:
				self.netmaskEntry.modify_base(gtk.STATE_NORMAL,gtk.gdk.color_parse("#f00"))
				allok = False
			if self.ipcheck(newgateway):
				command.append("-gateway")
				command.append(newgateway)
			else:
				self.gatewayEntry.modify_base(gtk.STATE_NORMAL,gtk.gdk.color_parse("#f00"))
				allok = False
			if newextrans != "" :
				if self.ipcheck(newextrans):
					command.append("-extra-ns")
					command.append(newextrans)
				else:
					self.extransEntry.modify_base(gtk.STATE_NORMAL,gtk.gdk.color_parse("#f00"))
					allok = False
		if allok :
			pprocess = subprocess.Popen(command,stdout = subprocess.PIPE,stderr = subprocess.PIPE)
			pprocess.communicate()
			pprocess1 = subprocess.Popen(["/etc/init.d/networking","restart"],stdout = subprocess.PIPE,stderr = subprocess.PIPE)
			self.window.destroy()
	#def applyButtonPress
	
#class NatManager

if __name__=="__main__":
	
	nc=NetConfig()
